<?php

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* 
/**
 *   Local User Environment.
 *
 * This sets up the local configuration array with the values set by the user's
 * "paloose.php" file in their site home page. See the example on the
 * Paloose site (see {@link http://www.paloose.org/pp/documentation/simpleSite.html})
 * for how to set this. Look in the file paloose.php.dist for an explanation of all these.
 * 
 * Paloose is free software: you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details. 
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program.  If not, see <http://www.gnu.org/licenses/> 
 *
 * @author Hugh Field-Richards <hsfr@hsfr.org.uk>
 * @package paloose
 * @subpackage Paloose
 * @version See {@link Paloose.php}
 * @copyright 2006 - 2009 Hugh Field-Richards
 */

$gConfiguration[ 'loggerConfig' ] = defined( 'LOGGER_CONFIG' ) ? LOGGER_CONFIG : "context://configs/Paloose.xml" ;
$gConfiguration[ 'rootSiteMap' ] = defined( 'ROOT_SITEMAP' ) ? ROOT_SITEMAP : "sitemap.xmap";
$gConfiguration[ 'userExceptionPage' ] = defined( 'USER_EXCEPTION_PAGE' ) ? USER_EXCEPTION_PAGE : "resource://resources/errorHandling/userError.html";
$gConfiguration[ 'userExceptionTransform' ] = defined( 'USER_EXCEPTION_TRANSFORM' ) ? USER_EXCEPTION_TRANSFORM : "resource://resources/transforms/errorPage2html.xsl";
$gConfiguration[ 'userExceptionStyle' ] = defined( 'USER_EXCEPTION_STYLE' ) ? USER_EXCEPTION_STYLE : "/paloose/resources/styles/userError.css";
$gConfiguration[ 'internalExceptionPage' ] = defined( 'INTERNAL_EXCEPTION_PAGE' ) ? INTERNAL_EXCEPTION_PAGE : "resource://resources/errorHandling/internalError.html";
$gConfiguration[ 'internalExceptionTransform' ] = defined( 'INTERNAL_EXCEPTION_TRANSFORM' ) ? INTERNAL_EXCEPTION_TRANSFORM : "resource://resources/transforms/errorPage2html.xsl";
$gConfiguration[ 'internalExceptionStyle' ] = defined( 'INTERNAL_EXCEPTION_STYLE' ) ? INTERNAL_EXCEPTION_STYLE : "/paloose/resources/styles/internalError.css";
$gConfiguration[ 'sitemapNamespace' ] = defined( 'SITEMAP_NAMESPACE' ) ? SITEMAP_NAMESPACE : "http://apache.org/cocoon/sitemap/1.0";
$gConfiguration[ 'sourceNamespace' ] = defined( 'SOURCE_NAMESPACE' ) ? SOURCE_NAMESPACE : "http://apache.org/cocoon/source/1.0";
$gConfiguration[ 'dirNamespace' ] = defined( 'DIR_NAMESPACE' ) ? DIR_NAMESPACE : "http://apache.org/cocoon/directory/2.0";
$gConfiguration[ 'i18nNamespace' ] = defined( 'I18N_NAMESPACE' ) ? I18N_NAMESPACE : "http://apache.org/cocoon/i18n/2.1";
$gConfiguration[ 'sqlNamespace' ] = defined( 'SQL_QUERY_NAMESPACE' ) ? SQL_QUERY_NAMESPACE : "http://apache.org/cocoon/SQL/2.0";
$gConfiguration[ 'pageHitTransform' ] = defined( 'PAGE_HIT_TRANSFORM' ) ? PAGE_HIT_TRANSFORM : "resource://resources/transforms/PageHit.xsl";
$gConfiguration[ 'palooseNamespace' ] = defined( 'PALOOSE_NAMESPACE' ) ? PALOOSE_NAMESPACE : "http://www.paloose.org/schemas/Paloose/1.0";
$gConfiguration[ 'XHTMLNamespace' ] = defined( 'XHTML_NAMESPACE' ) ? XHTML_NAMESPACE : "http://www.w3.org/1999/xhtml";
$gConfiguration[ 'galleryIndex' ] = defined( 'GALLERY_INDEX' ) ? GALLERY_INDEX : "gallery.xml";
$gConfiguration[ 'ImageMagickBin' ] = defined( 'IMAGEMAGICK_BIN' ) ? IMAGEMAGICK_BIN : "";
$gConfiguration[ 'cacheDir' ] = defined( 'CACHE_DIR' ) ? CACHE_DIR : "";

?>